# Git Projects

The projects under analysis are accessible via the following links

* https://gitlab.soft.vub.ac.be/ward/zeller-argouml-20100617
* https://gitlab.soft.vub.ac.be/ward/zeller-gwt-20110519
* https://gitlab.soft.vub.ac.be/ward/zeller-jaxen-20100607
* https://gitlab.soft.vub.ac.be/ward/zeller-jruby-20100703
* https://gitlab.soft.vub.ac.be/ward/zeller-xstream-20110309

# Commit Categorisation

The categorisation of commits is placed in the `commits/` directory. Every file
states the in its name what category and project it is. The original
categorisation before our filtering is also provided.

# Tool Analysis

The `tool-analysis/` folder holds:

* `results/`: the results of running our tool on the given commits.
* `scripts/`: the scripts used to go from the results to something
  presentable for the paper.

# Survey

In `survey/` are both the results of the mini survey as well as a python script
to squeeze the numbers and graphs out of it.

# Python Requirements

I did not check in detail which libraries are needed, I am using the default
Anaconda installation for Python 3. `numpy` and `matplotlib` are definitely
required (and part of that installation). Note that in at least one of the plot
creations I am using matplotlib's `tex` option to create a PDF, I believe you
need a LaTeX installation for that to work as intended.

# Anything Missing?

Just contact Ward Muylaert.

* ward.muylaert@vub.be
* https://soft.vub.ac.be/~wmuylaer/
