#!/usr/bin/env python3
"""Analysing of the results for slicing paper"""

import itertools

import datareader
import config

import matplotlib.pyplot as plt
import numpy
import scipy.stats




results = datareader.load_results(config.PROJECT_NAMES, config.CATEGORIES, config.RESULT_FOLDER)
filtered_results = datareader.filter_results(results, config.PROJECT_NAMES, config.CATEGORIES)
final_results = datareader.filter_results_with_manual(filtered_results,
                                                      config.PROJECT_NAMES,
                                                      config.CATEGORIES)

blob_info = datareader.load_blob_info(config.PROJECT_NAMES, './dataset-blobs/')

print('Parsed results')


###############################################################################
#### Stuff ####################################################################
###############################################################################

def mean_clusters(res):
    return numpy.mean([r.clusters for r in res])

#forall_projects(mean_clusters, filtered_results)

def is_poisson(result):
    """if p < 0.05, you can reject similarity"""
    clusters = [r.clusters for r in result]
    counts, bins, patches = plt.hist(clusters, bins=range(10), normed=True)
    theoretical, _, _ = plt.hist(scipy.stats.poisson.rvs(numpy.mean(clusters), size=100000), bins=range(10), normed=True)
    chisq, p = scipy.stats.chisquare(counts, theoretical, ddof=2)
    print(chisq, p)

#is_poisson([x for x in results[project][category] if x.node_found > 0])


# Bins are [x, y[
#bins = range(20)
#plt.hist([x.clusters for x in filtered_results['argouml']['atomic']], bins = bins, normed=True, alpha=0.7)
##plt.show()
#plt.axvline(numpy.median([x.clusters for x in filtered_results['argouml']['atomic']]))
#plt.hist([x.clusters for x in filtered_results['argouml']['tangled']], bins = bins, normed=True, alpha=0.5)
#plt.axvline(numpy.median([x.clusters for x in filtered_results['argouml']['tangled']]))
    
def find_one_file_changes(results):
    for project in results:
        for category in results[project]:
            grouped = itertools.groupby(results[project][category], lambda r: r.sha)
            for sha, files in grouped:
                files = list(files)
                if len(files) == 1:
                    if (category == 'atomic' and files[0].clusters == 1) or category == 'tangled':
                        print(category, files[0])

find_one_file_changes(final_results)